urls.py
from django.conf import settings
from django.urls import include, path, re_path
from django.conf.urls import include, url
from . import views
from gestruc.views import IndexView, NourrissementList
from django.views.generic import TemplateView, ListView

app_name = 'gestruc'

urlpatterns = [
    path('', IndexView.as_view(),name='index'),
    path('ruchers/', views.ruchers_list, name='ruchers'),
    path('miellerie/', views.miellerie, name='miellerie'),
    path('interventions/', views.interventions, name='interventions'),
    path('validation/', views.validation, name='validation'),
    path('ruchers/<int:pk>/', views.rucher_detail, name='rucher_detail'),
    path('ruchers/add/', views.rucher_create, name='rucher_add'),
    path('ruchers/<int:pk>/edit/', views.rucher_update, name='rucher_update'),
    path('ruchers/<int:pk>/del/', views.rucher_delete, name='rucher_delete'),
    path('ruches/<int:pk>/', views.ruche_detail, name='ruche_detail'),
    path('ruches/<int:pk>/colonie', views.colonie_detail, name='colonie_detail'),
    path('visites/', views.visites_list, name='visites'),
    path('visites/<int:pk>/', views.visite_detail, name='visite_detail'),
    path('visites/add/', views.VisiteCreateView.as_view(), name='visite_add'),
    path('visites/ajax/load-affectation/', views.load_affectation, name='ajax_load_affectation'),
    path('sites/', views.SiteListView.as_view(), name='sites_list'),
    path('sites/add/', views.SiteCreateView.as_view(), name='site_add'),
    path('sites/<int:pk>/', views.SiteUpdateView.as_view(), name='site_update'),
    path('sites/ajax/load-communes/', views.load_communes, name='ajax_load_communes'),
    path('affectations/',views.aff_list, name='aff_list'),
    path('affectations/all/',views.aff_hist, name='aff_hist'),
    path('affectations/<int:pk>/', views.aff_ruruchcol_detail, name='aff_ruruchcol_detail'),
    path('affectations/add/', views.aff_ruruchcol_create, name='aff_ruruchcol_add'),
    path('affectations/<int:pk>/del/', views.aff_ruruchcol_delete, name='aff_del'),
    path('affectations/<int:pk>/fin/', views.aff_ruruchcol_fin, name='aff_fin'),
    path('interventions/', views.interventions, name='interventions'),
    path('interventions/ajax/load-affectation/', views.load_affectation, name='ajax_load_affectation'),
    path('interventions/add/', views.IntervCreateView.as_view(), name='interv_add'),
    path('interventions/nourrissement/list', NourrissementList.as_view(), name='nour_list'),

    path('interventions/nourrissement/add/', views.NourrissementCreate.as_view(), name='nour_add'),

    path('interventions/nourrissement/<int:pk>/', views.NourrissementUpdate.as_view(), name='nour_update'),

    path('interventions/essaim', views.essaim, name='essaim'),
    path('interventions/mvt_cadres', views.mvt_cadres, name='mvt_cadres'),
    path('interventions/varroa', views.varroa, name='varroa'),
    path('interventions/recolte', views.recolte, name='recolte'),
    path('toto', views.toto, name='toto'),
]

models.py
## test de modif


from django.db import models
from django.contrib.gis.db import models
import datetime
from django.utils import  timezone
from django.urls import reverse


class Departement(models.Model):
    insee_dep = models.CharField(primary_key=True, max_length=3, blank=True, null=False)
    nom_dep_m = models.CharField(max_length=50, blank=True, null=True)
    nom_dep = models.CharField(max_length=45, blank=True, null=True)

    class Meta:
        ordering = ["nom_dep_m"]

    def __str__(self):
        return self.nom_dep_m


class Commune(models.Model):
    insee_com = models.CharField(primary_key=True, max_length=5, blank=True, null=False)
    insee_dep = models.ForeignKey(Departement, on_delete=models.CASCADE)
    nom_com_m = models.CharField(max_length=50, blank=True, null=True)
    nom_com = models.CharField(max_length=45, blank=True, null=True)
    # commentaire = models.TextField(max_length=200, blank=True, null=True)

    class Meta:
        ordering = ["nom_com_m"]

    def __str__(self):
        return self.nom_com_m


class Site(models.Model):
    nom_site = models.CharField(max_length=50, blank=True, null=True)
    code_site = models.CharField(max_length=20, blank=True, null=True)
    departement = models.ForeignKey(Departement, on_delete=models.CASCADE, blank=True, null=True)
    commune = models.ForeignKey(Commune, on_delete=models.CASCADE, blank=True, null=True)

    def __str__(self):
        return self.nom_site


class Communes(models.Model):
    insee_com = models.CharField(max_length=5, blank=True, null=True)
    insee_dep = models.CharField(max_length=3, blank=True, null=True)
    nom_com_m = models.CharField(max_length=50, blank=True, null=True)
    nom_com = models.CharField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.nom_com_m


class Ruchers(models.Model):
    nom_rucher = models.CharField(max_length=25, blank=True, null=True)
    code_rucher = models.CharField(max_length=20, blank=True, null=True)
    dept = models.CharField (max_length=2, blank=True, null=True)
    commune = models.ForeignKey(Communes, on_delete=models.CASCADE, blank=True, null=True)
    lieudit = models.CharField(max_length=50, blank=True, null=True)
    statut_rucher = models.BooleanField(blank=True, null=False, default=False)
    bio = models.BooleanField(blank=True, null=False, default=False)
    geom = models.PointField(blank=True, null=True)

    def get_absolute_url(self):
        return reverse('gestruc:rucher-detail', kwargs={'pk': str(self.pk)})

    def __str__(self):
        return self.nom_rucher


class Typ_ruche(models.Model):
    ruchette = models.BooleanField(blank=True, null=False, default=False)
    modele = models.CharField(max_length=30, blank=True, null=True)
    description = models.TextField (max_length=200, blank=True, null=True)

    def __str__(self):
        return self.modele


class Ruches(models.Model):
    code_ruche = models.CharField(max_length=10, blank=False, null=False, unique=True)
    type_ruche = models.ForeignKey(Typ_ruche, on_delete=models.CASCADE, blank=True, null=True)
    date_mes = models.DateField(("Date mise en service"), default=datetime.date.today)
    statut_bio = models.BooleanField(blank=True, null=False, default=False)
    affectation = models.BooleanField(default = False)
    commentaire = models.TextField(max_length=200, blank=True, null=True)

    def get_absolute_url(self):
        return reverse('gestruc:ruche-detail', kwargs={'pk': str(self.pk)})

    def __str__(self):
        return self.code_ruche


class Note_etat(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=20, blank=True, null=True)

    def __str__(self):
        return self.description


class Phenotypes(models.Model):
    phenotype = models.CharField(max_length=10, blank=True, null=True)
    description = models.TextField(max_length=200, blank=True, null=True)

    def __str__(self):
        return self.phenotype


class Note_agress(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Note_essaim(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Note_prod(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Note_varroa(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Colonies(models.Model):
    code_col = models.CharField(max_length=20, blank=True, null=False, unique=True)
    annee_reine = models.CharField(max_length=4, blank=False, null=False, default='2000')
    phenotype = models.ForeignKey(Phenotypes, on_delete=models.CASCADE)
    agressivite = models.ForeignKey(Note_agress, on_delete=models.CASCADE)
    essaimage = models.ForeignKey(Note_essaim, on_delete=models.CASCADE)
    production = models.ForeignKey(Note_prod, on_delete=models.CASCADE)
    varroa = models.ForeignKey(Note_varroa, on_delete=models.CASCADE)
    existante = models.BooleanField(default = True)
    affectation = models.BooleanField(default = False)
    commentaire = models.TextField(max_length=200, blank=True, null=True)

    def get_absolute_url(self):
        return reverse('gestruc:colonie-detail', kwargs={'pk': str(self.pk)})

    def __str__(self):
        return self.code_col


class Ruruchcol(models.Model):
    rucher = models.ForeignKey(Ruchers, related_name='rucher', on_delete=models.CASCADE,null=False)
    ruche = models.ForeignKey(Ruches,related_name='ruche', on_delete=models.CASCADE, null=False)
    colonie = models.ForeignKey(Colonies,related_name='colonie', on_delete=models.CASCADE, null=False)
    emplacement = models.CharField(max_length=10, blank=True, null=True)
    debut = models.DateTimeField('Date début')
    fin = models.DateTimeField('Date de fin', blank =True, null=True)
    commentaire = models.TextField(max_length=240, blank=True, null=True)

    def ruruchcol_encours(self):
        return self.objects.filter(fin__isnull=True)
     
    def get_absolute_url(self):
        return reverse('gestruc:Affruruchcol_detail', kwargs={'pk': str(self.pk)})

    def __str__(self):
       return 'ruche={0}, colonie={1}'.format(self.ruche.code_ruche, self.colonie.code_col)
       #return 'rucher={0}, ruche={1}, colonie={2}'.format(self.rucher.nom_rucher, self.ruche.code_ruche, self.colonie.code_col)


class Operateur(models.Model):
    pseudo = models.CharField(max_length=20)
    nom = models.CharField(max_length=20, blank=True, null=True)
    prenom = models.CharField(max_length=20, blank=True, null=True)
    infos = models.TextField(max_length=200, blank=True, null=True)
    def __str__(self):
        return self.pseudo


class Typ_visite(models.Model):
    lib_visit = models.CharField(max_length=50, blank=True, null=True)
    description = models.TextField (max_length=200, blank=True, null=True)

    def __str__(self):
        return self.lib_visit


class Motif_visite(models.Model):
    lib_motif = models.CharField(max_length=50, blank=True, null=True)
    description = models.TextField (max_length=200, blank=True, null=True)

    def __str__(self):
        return self.lib_motif


class Etat_ponte(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Etat_couv_ouvert(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Etat_couv_ferme(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Etat_miel(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Etat_pollen(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Activite_reine(models.Model):
    libelle = models.CharField(max_length=20, null=True )
    description = models.TextField(max_length=200, blank=True, null=True)

    def __str__(self):
        return self.libelle


class Note_globale(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Pression_frelon(models.Model):
    note = models.CharField(max_length=2)
    description = models.TextField(max_length=50, blank=True, null=True)

    def __str__(self):
        return self.description


class Gestion_hausses(models.Model):
    libelle = models.CharField(max_length=20, null=True )
    description = models.TextField(max_length=200, blank=True, null=True)

    def __str__(self):
        return self.libelle


class Visites(models.Model):
    datevis     =models.DateTimeField('date Visite')
    operateur = models.ManyToManyField(Operateur)
    rucher = models.ForeignKey(Ruchers, on_delete=models.CASCADE,null=True)
    ide_visit = models.CharField(max_length=20, blank=False, null=True, unique=True)
    affectation = models.ForeignKey(Ruruchcol, on_delete=models.CASCADE,null=True)
    type_visite = models.ForeignKey(Typ_visite, on_delete=models.CASCADE, null=True)

templates/gestruc/VisiteDetailForm.html
{% extends 'gestruc/base.html' %}

{% block content %}

<H2> It works </H2>
<H1> Detail de la visite n° {{visite.id}} </H1>

<form method="get">

    {{ form.as_p }}


</form>

{% endblock %}

templates/gestruc/aff_ruruchcol_detail.html
{% extends 'gestruc/base.html' %}

{% block content %}

<H1> Detail de l'affectation rucher - ruche - colonie n° {{ruruchcol.id}}</H1>

<form  method="post">
    {% csrf_token %}

    {{ form.as_p }}

<input type="submit" value="Confirmer les modifications">
<a href="{% url 'gestruc:aff_list' %}"> <b> Retour liste des affectations </b></a>
</form>




{% endblock %}

templates/gestruc/colonie_detail.html
{% extends 'gestruc/base.html' %}

{% block content %}

<H1> Detail d'une colonie </H1>

<form method="get">
  {% csrf_token %}

     {{ form.as_table }}

<H3>Historique des ruches/ruchers occupés:</H3>

  <ul>
    {% for r in ruchcol %}
        <li>
          <a href="{% url 'gestruc:ruche_detail' r.ruche_id %}">{{ r.ruche }}
          </a>

          <a href="{% url 'gestruc:rucher_detail' r.rucher_id %}">{{ r.rucher }}
          </a>
          ---{{ r.debut }} >>{{ r.fin }}
        </li>
    {% endfor %}
    </ul>

   <a href="{% url 'gestruc:ruchers' %}"> Retour </a>



</form>



{% endblock %}

templates/gestruc/essaim.html
{% extends 'gestruc/base.html' %}

{% block content %}

<class="intro-text text-center"><h2>Vous êtes sur la page Essaims</h2></h2>

<a href="{% url 'gestruc:interventions' %}">retour</a>


{% endblock %}

templates/gestruc/index.html
{% extends 'gestruc/base.html' %}

{% block content %}

  <div class="row">
            <div class="box">
                <div class="col-lg-12">
                    <hr>
                    <h3 >les dernières informations enregistrées dans
                        <strong>Ruchers & miellerie :</strong>
                    </h3>

                        <ul>

                            <li> Les dernières interventions ...       </li>

                            <li> Les prochaines visites programmées ....        </li>
                        </ul>
                </div>
            </div>
        </div>

{% endblock %}

{% block content1 %}

  <div class="row">
            <div class="box">
                <div class="col-lg-12">
                    <hr>
                    <h3 >Les interventions et visites programmées
                    </h3>

                        <ul>

                            <li> Des échéances les plus proches...      </li>

                            <li> ... aux échéances les plus éloignées ....        </li>
                        </ul>
                </div>
            </div>
        </div>

{% endblock %}

templates/gestruc/miellerie.html
{% extends 'gestruc/base.html' %}

{% block content %}

<class="intro-text text-center"><h2>Vous êtes sur la page MIELLERIE</h2></h2>



{% endblock %}

templates/gestruc/nour_detail.html
{% extends 'gestruc/base.html' %}

{% block content %}

<H1> Detail du nourrissement {{nour.id}} </H1>

<form method="get">
  {% csrf_token %}

    {{ form.as_p }}

  <a href="{% url 'gestruc:nourrissement_list' %}"> Retour</a>
</form>


{% endblock %}

templates/gestruc/rucher_add.html
{% extends 'gestruc/base.html' %}

{% block content %}

<form action="{% url 'gestruc:rucher_add' %}" method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Valider" />
</form>


{% endblock %}

templates/gestruc/ruches_list.html
{% extends 'gestruc/base.html' %}

{% block content %}

<h2>liste des ruches : </h2><br>

  {% if ruches|length_is:"0" %}
    <div class="test-center">
      Nous ne trouvons aucun résultat à cette requête, veuillez essayer de nouveau avec d'autres paramètres de recherche.
    </div>

{% else %}

    <ul>
        {% for ruche in ruches %}
          <li>
               {{ ruche.id }}    {{ ruche.code_rucher}}
          </li>
        {% endfor %}
    </ul>

{% endif %}






{% endblock %}

templates/gestruc/site_list.html
{% extends 'gestruc/base.html' %}

{% block content %}

<class="intro-text text-center"><h2>Vous êtes sur la page des SITES</h2></h2>



{% endblock %}

templates/gestruc/toto.html
<!doctype html>
<html lang="fr">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

    <!-- Ces styles sont fait pour mettre en valeur les lignes et les colonnes et aider à visualiser le rendu avec Bootstrap 4 -->
    <style>
      .row {
        border: 1px solid #7451EB;
        padding: 3px;
      }
      [class^="col"] {
        padding: 1rem;
        border: 2px solid #3FA5DB;
      }
    </style>

    <title>Grille Boostrap</title>
  </head>
  <body>

   <div class="row">
      <div class="col">
         Première colonne

                <form action="{% url 'gestruc:visite_add' %}" method="post">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <input type="submit" value="Valider" />
                    <a href="{% url 'gestruc:visites' %}"> <b> annuler </b></a>
                </form>

      </div>
      <div class="col">
         Deuxième colonne
      </div>
   </div>
</div>

templates/gestruc/validation.html
{% extends 'gestruc/base.html' %}

{% block content %}

<class="intro-text text-center"><h2>Vos données ont correctement été enregistrées </h2></h2>



{% endblock %}

templates/gestruc/visite_add.html
{% extends 'gestruc/base.html' %}


          {% block content %}

          <H1> Saisie d'une nouvelle visite </H1>

              <form action="{% url 'gestruc:visite_add' %}" method="post">
                  {% csrf_token %}
                  {{ form.as_p }}
                  <input type="submit" value="Valider" />
                  <a href="{% url 'gestruc:visites' %}"> <b> annuler </b></a>
              </form>

          {% endblock %}

templates/gestruc/visites_form.html
{% extends 'gestruc/base.html' %}

{% block content %}

  <h2>formulaire VISITES</h2>

  <form method="post" id="VisiteForm" data-visit-url="{% url 'gestruc:ajax_load_affectation' %}" novalidate>
    {% csrf_token %}
    <table>
      {{ form.as_table }}
    </table>
    <button type="submit">Enregistrer</button>
    <a href="{% url 'gestruc:visites' %}">Ignorer</a>
  </form>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

  <script>
    $("#id_rucher").change(function () {
      var url = $("#VisiteForm").attr("data-visit-url");  // get the url of the `load_cities` view
      var rucherId = $(this).val();  // get the selected country ID from the HTML input

      $.ajax({                       // initialize an AJAX request
        url: url,                    // set the url of the request (= localhost:8000/hr/ajax/load-cities/)
        data: {
          'rucher': rucherId       // add the country id to the GET parameters
        },
        success: function (data) {   // `data` is the return of the `load_cities` view function
          $("#id_affectation").html(data);  // replace the contents of the city input with the data that came from the server
        }
      });

    });
  </script>

{% endblock %}